var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled from 'styled-components';
import defaultTheme from "../../../theme";
import { Header, Text } from "../../elements/Text";
import { Icon } from "../../elements";
/**
 * MessageWrapper
 */
var MessageWrapper = styled.div.withConfig({ displayName: "MessageWrapper", componentId: "sc-koa2ht" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n"], ["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n"])));
/**
 * MessageHeader
 */
var MessageHeader = styled(Header).withConfig({ displayName: "MessageHeader", componentId: "sc-1h953we" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  padding-bottom: 0.25rem;\n  font-weight: 700;\n"], ["\n  padding-bottom: 0.25rem;\n  font-weight: 700;\n"])));
/**
 * MessageContent
 */
var MessageContent = styled(Text).withConfig({ displayName: "MessageContent", componentId: "sc-8e460s" })({
    margin: 0,
});
export var Message = styled(function (_a) {
    var theme = _a.theme, rest = __rest(_a, ["theme"]);
    var header = rest.header, content = rest.content, icon = rest.icon, onDismiss = rest.onDismiss;
    var headerNode = header && React.createElement(MessageHeader, { as: "h2" }, header);
    var contentNode = content && React.createElement(MessageContent, null, content);
    if (Icon) {
        return (React.createElement("div", __assign({}, rest),
            React.createElement(MessageWrapper, null,
                icon && React.createElement(Icon, { name: icon, className: "icon", size: "huge" }),
                React.createElement("div", { className: "content" },
                    headerNode,
                    contentNode),
                onDismiss && (React.createElement(Icon, { color: "white", onClick: onDismiss, name: "times", size: "huge" })))));
    }
    return (React.createElement("div", __assign({}, rest),
        headerNode,
        contentNode));
}).withConfig({ displayName: "Message", componentId: "sc-1nxdrim" })({
    position: 'relative',
    minHeight: '1em',
    padding: '1em 1.5em',
    lineHeight: '1.5em',
    maxHeight: '150px',
    textAlign: 'left',
}, 
// Handle message colours
function (_a) {
    var theme = _a.theme, info = _a.info, success = _a.success, negative = _a.negative, error = _a.error, warning = _a.warning;
    var isNegative = negative || error;
    var backgroundColor;
    if (info) {
        backgroundColor = theme.colors.blue.default;
    }
    else if (success) {
        backgroundColor = theme.colors.green.default;
    }
    else if (isNegative) {
        backgroundColor = theme.colors.red.default;
    }
    else if (warning) {
        backgroundColor = theme.colors.orange.default;
    }
    else {
        backgroundColor = theme.greyscale.dark;
    }
    return {
        color: theme.colors.white.default,
        backgroundColor: backgroundColor,
        '& > .icon': {
            color: theme.colors.white.default,
        },
    };
}, 
// Handle icon
function (_a) {
    var icon = _a.icon;
    return icon
        ? {
            display: 'flex',
            alignItems: 'center',
            '& > .content': {
                display: 'block',
                flex: '1 1 auto',
                verticalAlign: 'middle',
            },
            '& > .icon': {
                display: 'block',
                flex: '0 0 auto',
                opacity: 0.8,
                marginRight: '0.6em',
            },
        }
        : null;
});
Message.defaultProps = {
    theme: defaultTheme,
};
var templateObject_1, templateObject_2;
