import { useWidgetContext } from '../context';
import { useFetchSessions } from './useFetchSessions';
var buildLuceneQuery = function (options, scopeId) {
    var baseQuery = '(+ogit\\/_type:"ogit/Knowledge/AcquisitionSession")';
    var optionsQuery = options.join(' ');
    return baseQuery + " AND (" + optionsQuery + ") AND (+ogit\\/_scope:\"" + scopeId + "\")";
};
export var useSessionsData = function (handleSession, getQueryOptions, sessionOptions) {
    if (sessionOptions === void 0) { sessionOptions = {}; }
    var _a = useWidgetContext(), title = _a.config.title, _b = _a.provider, selectAppsIds = _b.selectAppsIds, openApp = _b.openApp, selectMe = _b.selectMe, selectScopeId = _b.selectScopeId;
    var scopeId = selectScopeId();
    var atqId = selectAppsIds().atqId;
    var goToAction = function () { return openApp(atqId, sessionOptions); };
    var me = selectMe();
    var querystring = buildLuceneQuery(getQueryOptions(me.id), scopeId);
    var _c = useFetchSessions(querystring, handleSession), sessions = _c.sessions, loading = _c.loading, error = _c.error;
    return {
        title: title,
        sessions: sessions,
        loading: loading,
        error: error,
        goToAction: goToAction,
    };
};
