var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { Box, Header } from "../../../elements";
import { Dimmer } from "../../../modules";
import { Button } from "../../../inputs";
import { ButtonType } from '../../types';
import { formatNumber } from '../../utils';
import { WelcomeContainer } from './styles';
import { SessionsCountBox } from './SessionsCountBox';
import { SessionsText } from './SessionsText';
import { WelcomeLoader } from './WelcomeLoader';
var SessionsInfo = function (sessionsButtonConfig) {
    var text = sessionsButtonConfig.text, onClick = sessionsButtonConfig.onClick, buttonText = sessionsButtonConfig.buttonText, _a = sessionsButtonConfig.buttonTextCount, buttonTextCount = _a === void 0 ? 0 : _a, _b = sessionsButtonConfig.btnType, btnType = _b === void 0 ? ButtonType.primary : _b;
    var _c = React.useState(false), hovered = _c[0], setHover = _c[1];
    var handleEnter = function () {
        setHover(true);
    };
    var handleLeave = function () {
        setHover(false);
    };
    return (React.createElement(SessionsCountBox, { btnType: btnType, onMouseEnter: handleEnter, onMouseLeave: handleLeave },
        React.createElement(Box, null,
            React.createElement(SessionsText, { textAlign: "center", fontSize: "18px" }, buttonText),
            React.createElement(SessionsText, { textAlign: "center", fontSize: "88px" }, formatNumber(buttonTextCount))),
        hovered && (React.createElement(Dimmer, { active: true },
            React.createElement(Button, { secondary: true, onClick: onClick }, text)))));
};
export var WelcomePresenter = function (_a) {
    var loading = _a.loading, error = _a.error, _b = _a.sessionsButtonsConfig, sessionsButtonsConfig = _b === void 0 ? [] : _b, greeting = _a.greeting, subTitle = _a.subTitle;
    var content = error || (React.createElement(WelcomeContainer, null,
        React.createElement(Box, { floated: "left" },
            React.createElement(Header, { stretched: true }, greeting),
            React.createElement(Header, { as: "h2", color: "secondaryText" }, subTitle)),
        React.createElement("br", null),
        React.createElement(Box, { direction: "row", centered: "spaced", wrap: "nowrap" }, loading ? (React.createElement(WelcomeLoader, { count: sessionsButtonsConfig.length })) : (sessionsButtonsConfig.map(function (conf) { return (React.createElement(SessionsInfo, __assign({ key: conf.id }, conf))); })))));
    return React.createElement(Box, { centered: true }, content);
};
