import React from 'react';
import { StyledComponent, DefaultTheme } from 'styled-components';
import { HiroColors } from "../../../types";
export interface TableProps {
    striped?: boolean;
    celled?: boolean;
    sortable?: boolean;
    fixed?: boolean;
    singleLine?: boolean;
}
export declare const Table: StyledComponent<'table', DefaultTheme, TableProps, never>;
export declare const TableHeader: StyledComponent<"thead", DefaultTheme, {}, never>;
export interface TableHeaderCellProps extends React.HTMLProps<HTMLTableHeaderCellElement> {
    theme: DefaultTheme;
    children?: React.ReactNode;
    sorted?: 'ascending' | 'descending';
    small?: boolean;
    color?: HiroColors;
}
export declare const TableHeaderCell: StyledComponent<({ theme, children, sorted, ...rest }: TableHeaderCellProps) => JSX.Element, DefaultTheme, {}, never>;
export declare const TableBody: StyledComponent<"tbody", DefaultTheme, {}, never>;
export interface TableRowProps {
    color?: HiroColors;
    selected?: boolean;
    positive?: boolean;
    negative?: boolean;
    basic?: boolean;
    /** A list item can be dimmed to highlight a difference in state */
    dimmed?: boolean;
    highlighted?: boolean;
}
export declare const TableRow: StyledComponent<"tr", DefaultTheme, TableRowProps, never>;
export interface TableCellProps {
    maxWidth?: string;
    textAlign?: 'left' | 'right' | 'center' | 'justify';
    stretched?: boolean;
    fitted?: boolean;
    small?: boolean;
    width?: string | number;
    verticalAlign?: string;
}
export declare const TableCell: StyledComponent<"td", DefaultTheme, TableCellProps, never>;
